diff --git a/source/graphics/Terrain.cpp b/source/graphics/Terrain.cpp
index e38d2a6..fa90cfd 100644
--- a/source/graphics/Terrain.cpp
+++ b/source/graphics/Terrain.cpp
@@ -330,6 +330,58 @@ fixed CTerrain::GetSlopeFixed(ssize_t i, ssize_t j) const
 	return fixed::FromInt(delta / TERRAIN_TILE_SIZE) / (int)HEIGHT_UNITS_PER_METRE;
 }
 
+fixed CTerrain::GetExactSlopeFixed(fixed x, fixed z) const
+{
+	// Clamp to size-2 so we can use the tiles (xi,zi)-(xi+1,zi+1)
+	const ssize_t xi = clamp((ssize_t)(x / (int)TERRAIN_TILE_SIZE).ToInt_RoundToZero(), (ssize_t)0, m_MapSize-2);
+	const ssize_t zi = clamp((ssize_t)(z / (int)TERRAIN_TILE_SIZE).ToInt_RoundToZero(), (ssize_t)0, m_MapSize-2);
+
+	const fixed one = fixed::FromInt(1);
+
+	const fixed xf = clamp((x / (int)TERRAIN_TILE_SIZE) - fixed::FromInt(xi), fixed::Zero(), one);
+	const fixed zf = clamp((z / (int)TERRAIN_TILE_SIZE) - fixed::FromInt(zi), fixed::Zero(), one);
+
+	u16 h00 = m_Heightmap[zi*m_MapSize + xi];
+	u16 h01 = m_Heightmap[(zi+1)*m_MapSize + xi];
+	u16 h10 = m_Heightmap[zi*m_MapSize + (xi+1)];
+	u16 h11 = m_Heightmap[(zi+1)*m_MapSize + (xi+1)];
+
+	u16 delta;
+	if (GetTriangulationDir(xi, zi))
+	{
+		if (xf + zf <= one)
+		{
+			// Lower-left triangle (don't use h11)
+ 			delta = std::max(std::max(h00, h01), h10) -
+ 			        std::min(std::min(h00, h01), h10);
+		}
+		else
+		{
+			// Upper-right triangle (don't use h00)
+			delta = std::max(std::max(h01, h10), h11) -
+			        std::min(std::min(h01, h10), h11);
+		}
+	}
+	else
+	{
+		if (xf <= zf)
+		{
+			// Upper-left triangle (don't use h10)
+			delta = std::max(std::max(h00, h01), h11) -
+			        std::min(std::min(h00, h01), h11);
+		}
+		else
+		{
+			// Lower-right triangle (don't use h01)
+			delta = std::max(std::max(h00, h10), h11) -
+			        std::min(std::min(h00, h10), h11);
+		}
+	}
+
+	// Compute fractional slope (being careful to avoid intermediate overflows)
+	return fixed::FromInt(delta / TERRAIN_TILE_SIZE) / (int)HEIGHT_UNITS_PER_METRE;
+}
+
 float CTerrain::GetExactGroundLevel(float x, float z) const
 {
 	// Clamp to size-2 so we can use the tiles (xi,zi)-(xi+1,zi+1)
diff --git a/source/graphics/Terrain.h b/source/graphics/Terrain.h
index 4002eb5..b059879 100644
--- a/source/graphics/Terrain.h
+++ b/source/graphics/Terrain.h
@@ -88,6 +88,8 @@ public:
 	// get the approximate slope (0 = horizontal, 0.5 = 30 degrees, 1.0 = 45 degrees, etc)
 	fixed GetSlopeFixed(ssize_t i, ssize_t j) const;
 
+	fixed GetExactSlopeFixed(fixed x, fixed z) const;
+
 	// Returns true if the triangulation diagonal for tile (i, j)
 	// should be in the direction (1,-1); false if it should be (1,1)
 	bool GetTriangulationDir(ssize_t i, ssize_t j) const;
diff --git a/source/graphics/TerritoryBoundary.cpp b/source/graphics/TerritoryBoundary.cpp
index da0fcd2..d9cbfb1 100644
--- a/source/graphics/TerritoryBoundary.cpp
+++ b/source/graphics/TerritoryBoundary.cpp
@@ -21,6 +21,7 @@
 #include <algorithm> // for reverse
 
 #include "graphics/Terrain.h"
+#include "simulation2/components/ICmpObstructionManager.h"
 #include "simulation2/components/ICmpTerritoryManager.h"
 
 std::vector<STerritoryBoundary> CTerritoryBoundaryCalculator::ComputeBoundaries(const Grid<u8>* territory)
@@ -125,7 +126,7 @@ std::vector<STerritoryBoundary> CTerritoryBoundaryCalculator::ComputeBoundaries(
 
 			while (true)
 			{
-				points.push_back((CVector2D(ci, cj) + edgeOffsets[cdir]) * TERRAIN_TILE_SIZE);
+				points.push_back((CVector2D(ci, cj) + edgeOffsets[cdir]) * (ICmpObstructionManager::NAVCELL_SIZE * ICmpTerritoryManager::NAVCELLS_PER_TERRITORY_TILE).ToFloat());
 
 				// Given that we're on an edge on a continuous boundary and aiming anticlockwise,
 				// we can either carry on straight or turn left or turn right, so examine each
diff --git a/source/graphics/TerritoryTexture.cpp b/source/graphics/TerritoryTexture.cpp
index 336be12..c420906 100644
--- a/source/graphics/TerritoryTexture.cpp
+++ b/source/graphics/TerritoryTexture.cpp
@@ -25,6 +25,7 @@
 #include "ps/Profile.h"
 #include "renderer/Renderer.h"
 #include "simulation2/Simulation2.h"
+#include "simulation2/components/ICmpObstructionManager.h"
 #include "simulation2/components/ICmpPlayer.h"
 #include "simulation2/components/ICmpPlayerManager.h"
 #include "simulation2/components/ICmpTerrain.h"
@@ -92,7 +93,7 @@ void CTerritoryTexture::ConstructTexture(int unit)
 	if (cmpTerrain.null())
 		return;
 
-	m_MapSize = cmpTerrain->GetVerticesPerSide() - 1;
+	m_MapSize = cmpTerrain->GetTilesPerSide() * ICmpObstructionManager::NAVCELLS_PER_TILE / ICmpTerritoryManager::NAVCELLS_PER_TERRITORY_TILE;
 
 	m_TextureSize = (GLsizei)round_up_to_pow2((size_t)m_MapSize);
 
diff --git a/source/gui/GUIManager.h b/source/gui/GUIManager.h
index 0edfd14..828e4c0 100644
--- a/source/gui/GUIManager.h
+++ b/source/gui/GUIManager.h
@@ -145,7 +145,6 @@ private:
 		CStrW name;
 		boost::unordered_set<VfsPath> inputs; // for hotloading
 
-		JSContext* cx;
 		CScriptValRooted initData; // data to be passed to the init() function
 
 		shared_ptr<CGUI> gui; // the actual GUI page
diff --git a/source/renderer/OverlayRenderer.cpp b/source/renderer/OverlayRenderer.cpp
index 53d6b59..5e225ff 100644
--- a/source/renderer/OverlayRenderer.cpp
+++ b/source/renderer/OverlayRenderer.cpp
@@ -166,6 +166,10 @@ void OverlayRenderer::RenderOverlaysBeforeWater()
 	glDisable(GL_TEXTURE_2D);
 	glEnable(GL_BLEND);
 
+	// Ignore z to draw behind terrain (but don't disable GL_DEPTH_TEST
+	// since we still need to write to the z buffer)
+	glDepthFunc(GL_ALWAYS);
+
 	for (size_t i = 0; i < m->lines.size(); ++i)
 	{
 		SOverlayLine* line = m->lines[i];
@@ -184,6 +188,7 @@ void OverlayRenderer::RenderOverlaysBeforeWater()
 	glDisableClientState(GL_VERTEX_ARRAY);
 
 	glLineWidth(1.f);
+	glDepthFunc(GL_LEQUAL);
 	glDisable(GL_BLEND);
 }
 
@@ -321,7 +326,7 @@ void OverlayRenderer::RenderForegroundOverlays(const CCamera& viewCamera)
 
 	glEnable(GL_TEXTURE_2D);
 	glEnable(GL_BLEND);
-	glDisable(GL_DEPTH_TEST);
+ 	glDisable(GL_DEPTH_TEST);
 
 	CVector3D right = -viewCamera.m_Orientation.GetLeft();
 	CVector3D up = viewCamera.m_Orientation.GetUp();
@@ -354,7 +359,7 @@ void OverlayRenderer::RenderForegroundOverlays(const CCamera& viewCamera)
 	glDisableClientState(GL_VERTEX_ARRAY);
 	glDisableClientState(GL_TEXTURE_COORD_ARRAY);
 
-	glEnable(GL_DEPTH_TEST);
+ 	glEnable(GL_DEPTH_TEST);
 	glDisable(GL_BLEND);
 	glDisable(GL_TEXTURE_2D);
 }
diff --git a/source/renderer/PatchRData.cpp b/source/renderer/PatchRData.cpp
index d6b3bb3..ab3450a 100644
--- a/source/renderer/PatchRData.cpp
+++ b/source/renderer/PatchRData.cpp
@@ -1026,7 +1026,7 @@ void CPatchRData::RenderStreams(const std::vector<CPatchRData*>& patches, int st
 
  	PROFILE_END("compute batches");
 
-	ENSURE(!(streamflags & ~(STREAM_POS|STREAM_COLOR|STREAM_POSTOUV1)));
+	ENSURE(!(streamflags & ~(STREAM_POS|STREAM_COLOR|STREAM_POSTOUV0|STREAM_POSTOUV1)));
 
  	// Render each batch
  	for (VertexBufferBatches::iterator itv = batches.begin(); itv != batches.end(); ++itv)
diff --git a/source/renderer/Renderer.cpp b/source/renderer/Renderer.cpp
index 2e2dcdf..d3d7578 100644
--- a/source/renderer/Renderer.cpp
+++ b/source/renderer/Renderer.cpp
@@ -1575,7 +1575,7 @@ void CRenderer::RenderSubmissions()
 	}
 
 	// render debug-related terrain overlays
-	TerrainOverlay::RenderOverlays();
+	ITerrainOverlay::RenderOverlaysBeforeWater();
 	ogl_WarnIfError();
 
 	// render other debug-related overlays before water (so they can be seen when underwater)
@@ -1606,6 +1606,10 @@ void CRenderer::RenderSubmissions()
 		ogl_WarnIfError();
 	}
 
+	// render debug-related terrain overlays
+	ITerrainOverlay::RenderOverlaysAfterWater();
+	ogl_WarnIfError();
+
 	// render some other overlays after water (so they can be displayed on top of water)
 	m->overlayRenderer.RenderOverlaysAfterWater();
 	ogl_WarnIfError();
@@ -2128,3 +2132,8 @@ CParticleManager& CRenderer::GetParticleManager()
 {
 	return m->particleManager;
 }
+
+TerrainRenderer& CRenderer::GetTerrainRenderer()
+{
+	return *m->terrainRenderer;
+}
diff --git a/source/renderer/Renderer.h b/source/renderer/Renderer.h
index 98d8e48..476f586 100644
--- a/source/renderer/Renderer.h
+++ b/source/renderer/Renderer.h
@@ -44,6 +44,7 @@ class SkyManager;
 class CTextureManager;
 class CShaderManager;
 class CParticleManager;
+class TerrainRenderer;
 
 // rendering modes
 enum ERenderMode { WIREFRAME, SOLID, EDGED_FACES };
@@ -265,6 +266,8 @@ public:
 
 	CParticleManager& GetParticleManager();
 
+	TerrainRenderer& GetTerrainRenderer();
+
 	/**
 	 * SetFastPlayerColor: Tell the renderer which path to take for
 	 * player colored models. Both paths should provide the same visual
diff --git a/source/renderer/TerrainOverlay.cpp b/source/renderer/TerrainOverlay.cpp
index 0e1e3d9..b1c1135 100644
--- a/source/renderer/TerrainOverlay.cpp
+++ b/source/renderer/TerrainOverlay.cpp
@@ -1,4 +1,4 @@
-/* Copyright (C) 2009 Wildfire Games.
+/* Copyright (C) 2012 Wildfire Games.
  * This file is part of 0 A.D.
  *
  * 0 A.D. is free software: you can redistribute it and/or modify
@@ -20,13 +20,16 @@
 #include "TerrainOverlay.h"
 
 #include "graphics/Terrain.h"
-#include "simulation2/system/SimContext.h"
+#include "lib/bits.h"
 #include "lib/ogl.h"
 #include "maths/MathUtil.h"
 #include "ps/Game.h"
 #include "ps/Overlay.h"
 #include "ps/Profile.h"
 #include "ps/World.h"
+#include "renderer/Renderer.h"
+#include "renderer/TerrainRenderer.h"
+#include "simulation2/system/SimContext.h"
 
 #include <algorithm>
 
@@ -54,23 +57,13 @@ private:
 	const equal1st& operator=(const equal1st& rhs);
 };
 
-/// Functor for calling ->Render on pairs' firsts.
-struct render1st
-{
-	template<typename S, typename T> void operator()(const std::pair<S, T>& a) const
-	{
-		a.first->Render();
-	}
-};
-
 //////////////////////////////////////////////////////////////////////////
 
 // Global overlay list management:
 
-static std::vector<std::pair<TerrainOverlay*, int> > g_TerrainOverlayList;
+static std::vector<std::pair<ITerrainOverlay*, int> > g_TerrainOverlayList;
 
-TerrainOverlay::TerrainOverlay(const CSimContext& simContext, int priority /* = 100 */)
-	: m_Terrain(&simContext.GetTerrain())
+ITerrainOverlay::ITerrainOverlay(int priority)
 {
 	// Add to global list of overlays
 	g_TerrainOverlayList.push_back(std::make_pair(this, priority));
@@ -81,48 +74,44 @@ TerrainOverlay::TerrainOverlay(const CSimContext& simContext, int priority /* =
 		compare2nd());
 }
 
-TerrainOverlay::~TerrainOverlay()
+ITerrainOverlay::~ITerrainOverlay()
 {
-	std::vector<std::pair<TerrainOverlay*, int> >::iterator newEnd =
+	std::vector<std::pair<ITerrainOverlay*, int> >::iterator newEnd =
 		std::remove_if(g_TerrainOverlayList.begin(), g_TerrainOverlayList.end(),
-			equal1st<TerrainOverlay*>(this));
+			equal1st<ITerrainOverlay*>(this));
 	g_TerrainOverlayList.erase(newEnd, g_TerrainOverlayList.end());
 }
 
 
-void TerrainOverlay::RenderOverlays()
+void ITerrainOverlay::RenderOverlaysBeforeWater()
 {
-	if (g_TerrainOverlayList.size() == 0)
+	if (g_TerrainOverlayList.empty())
 		return;
 
-	PROFILE3_GPU("terrain overlays");
+	PROFILE3_GPU("terrain overlays (before)");
 
-	glEnable(GL_BLEND);
-	glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
-	glDepthMask(GL_FALSE);
-	// To ensure that outlines are drawn on top of the terrain correctly (and
-	// don't Z-fight and flicker nastily), draw them as QUADS with the LINE
-	// PolygonMode, and use PolygonOffset to pull them towards the camera.
-	// (See e.g. http://www.opengl.org/resources/faq/technical/polygonoffset.htm)
-	glPolygonOffset(-1.f, -1.f);
-	glEnable(GL_POLYGON_OFFSET_LINE);
+	for (size_t i = 0; i < g_TerrainOverlayList.size(); ++i)
+		g_TerrainOverlayList[i].first->RenderBeforeWater();
+}
 
-	glDisable(GL_TEXTURE_2D);
+void ITerrainOverlay::RenderOverlaysAfterWater()
+{
+	if (g_TerrainOverlayList.empty())
+		return;
 
-	std::for_each(g_TerrainOverlayList.begin(), g_TerrainOverlayList.end(),
-		render1st());
+	PROFILE3_GPU("terrain overlays (after)");
 
-	// Clean up state changes
-	glEnable(GL_CULL_FACE);
-	glEnable(GL_DEPTH_TEST);
-	glDisable(GL_POLYGON_OFFSET_LINE);
-	glPolygonMode(GL_FRONT_AND_BACK, GL_FILL);
-	glDepthMask(GL_TRUE);
-	glDisable(GL_BLEND);
+	for (size_t i = 0; i < g_TerrainOverlayList.size(); ++i)
+		g_TerrainOverlayList[i].first->RenderAfterWater();
 }
 
 //////////////////////////////////////////////////////////////////////////
 
+TerrainOverlay::TerrainOverlay(const CSimContext& simContext, int priority /* = 100 */)
+	: ITerrainOverlay(priority), m_Terrain(&simContext.GetTerrain())
+{
+}
+
 void TerrainOverlay::StartRender()
 {
 }
@@ -140,11 +129,23 @@ void TerrainOverlay::GetTileExtents(
 	max_i_inclusive = max_j_inclusive = m_Terrain->GetTilesPerSide()-1;
 }
 
-void TerrainOverlay::Render()
+void TerrainOverlay::RenderBeforeWater()
 {
 	if (!m_Terrain)
 		return; // should never happen, but let's play it safe
 
+	glEnable(GL_BLEND);
+	glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
+	glDepthMask(GL_FALSE);
+	// To ensure that outlines are drawn on top of the terrain correctly (and
+	// don't Z-fight and flicker nastily), draw them as QUADS with the LINE
+	// PolygonMode, and use PolygonOffset to pull them towards the camera.
+	// (See e.g. http://www.opengl.org/resources/faq/technical/polygonoffset.htm)
+	glPolygonOffset(-1.f, -1.f);
+	glEnable(GL_POLYGON_OFFSET_LINE);
+
+	glDisable(GL_TEXTURE_2D);
+
 	StartRender();
 
 	ssize_t min_i, min_j, max_i, max_j;
@@ -162,6 +163,14 @@ void TerrainOverlay::Render()
 			ProcessTile(m_i, m_j);
 
 	EndRender();
+
+	// Clean up state changes
+	glEnable(GL_CULL_FACE);
+	glEnable(GL_DEPTH_TEST);
+	glDisable(GL_POLYGON_OFFSET_LINE);
+	glPolygonMode(GL_FRONT_AND_BACK, GL_FILL);
+	glDepthMask(GL_TRUE);
+	glDisable(GL_BLEND);
 }
 
 void TerrainOverlay::RenderTile(const CColor& colour, bool draw_hidden)
@@ -249,3 +258,59 @@ void TerrainOverlay::RenderTileOutline(const CColor& colour, int line_width, boo
 	if (line_width != 1)
 		glLineWidth(1.0f);
 }
+
+//////////////////////////////////////////////////////////////////////////
+
+TerrainTextureOverlay::TerrainTextureOverlay(float texelsPerTile, int priority) :
+	ITerrainOverlay(priority), m_TexelsPerTile(texelsPerTile), m_Texture(0), m_TextureW(0), m_TextureH(0)
+{
+	glGenTextures(1, &m_Texture);
+}
+
+TerrainTextureOverlay::~TerrainTextureOverlay()
+{
+	glDeleteTextures(1, &m_Texture);
+}
+
+void TerrainTextureOverlay::RenderAfterWater()
+{
+	CTerrain* terrain = g_Game->GetWorld()->GetTerrain();
+
+	ssize_t w = (ssize_t)(terrain->GetTilesPerSide() * m_TexelsPerTile);
+	ssize_t h = (ssize_t)(terrain->GetTilesPerSide() * m_TexelsPerTile);
+
+	pglActiveTextureARB(GL_TEXTURE0);
+
+	// Recreate the texture with new size if necessary
+	if (round_up_to_pow2(w) != m_TextureW || round_up_to_pow2(h) != m_TextureH)
+	{
+		m_TextureW = round_up_to_pow2(w);
+		m_TextureH = round_up_to_pow2(h);
+
+		glBindTexture(GL_TEXTURE_2D, m_Texture);
+
+		glTexImage2D(GL_TEXTURE_2D, 0, GL_RGBA8, m_TextureW, m_TextureH, 0, GL_RGBA, GL_UNSIGNED_BYTE, NULL);
+
+		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST);
+		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_NEAREST);
+		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP_TO_BORDER);
+		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP_TO_BORDER);
+	}
+
+	u8* data = (u8*)calloc(w * h, 4);
+	BuildTextureRGBA(data, w, h);
+
+	glBindTexture(GL_TEXTURE_2D, m_Texture);
+
+	glTexSubImage2D(GL_TEXTURE_2D, 0, 0, 0, w, h, GL_RGBA, GL_UNSIGNED_BYTE, data);
+
+	free(data);
+
+	CMatrix3D matrix;
+	matrix.SetZero();
+	matrix._11 = m_TexelsPerTile / (m_TextureW * TERRAIN_TILE_SIZE);
+	matrix._23 = m_TexelsPerTile / (m_TextureH * TERRAIN_TILE_SIZE);
+	matrix._44 = 1;
+
+	g_Renderer.GetTerrainRenderer().RenderTerrainOverlayTexture(matrix);
+}
diff --git a/source/renderer/TerrainOverlay.h b/source/renderer/TerrainOverlay.h
index 7d35581..45c6835 100644
--- a/source/renderer/TerrainOverlay.h
+++ b/source/renderer/TerrainOverlay.h
@@ -1,4 +1,4 @@
-/* Copyright (C) 2009 Wildfire Games.
+/* Copyright (C) 2012 Wildfire Games.
  * This file is part of 0 A.D.
  *
  * 0 A.D. is free software: you can redistribute it and/or modify
@@ -23,10 +23,39 @@
 #ifndef INCLUDED_TERRAINOVERLAY
 #define INCLUDED_TERRAINOVERLAY
 
+#include "lib/ogl.h"
+
 struct CColor;
 class CTerrain;
 class CSimContext;
 
+class ITerrainOverlay
+{
+	NONCOPYABLE(ITerrainOverlay);
+
+public:
+	virtual ~ITerrainOverlay();
+
+	virtual void RenderBeforeWater() { }
+
+	virtual void RenderAfterWater() { }
+
+	/**
+	 * Draw all ITerrainOverlay objects that exist
+	 * and that should be drawn before water.
+	 */
+	static void RenderOverlaysBeforeWater();
+
+	/**
+	 * Draw all ITerrainOverlay objects that exist
+	 * and that should be drawn after water.
+	 */
+	static void RenderOverlaysAfterWater();
+
+protected:
+	ITerrainOverlay(int priority);
+};
+
 /**
  * Base class for (relatively) simple drawing of
  * data onto terrain tiles, intended for debugging purposes and for the Atlas
@@ -42,13 +71,8 @@ class CSimContext;
  * A TerrainOverlay object will be rendered for as long as it exists.
  *
  */
-class TerrainOverlay
+class TerrainOverlay : public ITerrainOverlay
 {
-public:
-	virtual ~TerrainOverlay();
-private:
-	TerrainOverlay(){} // private default ctor (must be subclassed)
-
 protected:
 	/**
 	 * Construct the object and register it with the global
@@ -128,20 +152,9 @@ protected:
 	 */
 	void RenderTileOutline(const CColor& colour, int line_width, bool draw_hidden, ssize_t i, ssize_t j);
 	
-public:
-	/**
-	 * Draw all TerrainOverlay objects that exist.
-	 */
-	static void RenderOverlays();
-
 private:
-	/// Copying not allowed.
-	TerrainOverlay(const TerrainOverlay&);
-
-	friend struct render1st;
-
 	// Process all tiles
-	void Render();
+	virtual void RenderBeforeWater();
 
 	// Temporary storage of tile coordinates, so ProcessTile doesn't need to
 	// pass it to RenderTile/etc (and doesn't have a chance to get it wrong)
@@ -150,6 +163,35 @@ private:
 	CTerrain* m_Terrain;
 };
 
+/**
+ * Base class for texture-based terrain overlays, with an arbitrary number of
+ * texels per terrain tile, intended for debugging purposes.
+ * Subclasses must implement BuildTextureRGBA which will be called each frame.
+ */
+class TerrainTextureOverlay : public ITerrainOverlay
+{
+	NONCOPYABLE(TerrainTextureOverlay);
+public:
+	TerrainTextureOverlay(float texelsPerTile, int priority = 100);
+
+	virtual ~TerrainTextureOverlay();
+
+protected:
+	/**
+	 * Called each frame to generate the texture to render on the terrain.
+	 * @p data is w*h*4 bytes, where w and h are the terrain size multiplied
+	 * by texelsPerTile. @p data defaults to fully transparent, and should
+	 * be filled with data in RGBA order.
+	 */
+	virtual void BuildTextureRGBA(u8* data, size_t w, size_t h) = 0;
+
+private:
+	void RenderAfterWater();
+
+	float m_TexelsPerTile;
+	GLuint m_Texture;
+	GLsizei m_TextureW, m_TextureH;
+};
 
 /* Example usage:
 
diff --git a/source/renderer/TerrainRenderer.cpp b/source/renderer/TerrainRenderer.cpp
index 18703cd..f084794 100644
--- a/source/renderer/TerrainRenderer.cpp
+++ b/source/renderer/TerrainRenderer.cpp
@@ -243,7 +243,7 @@ void TerrainRenderer::RenderTerrain(bool filtered)
 
 	// switch on blending
 	glEnable(GL_BLEND);
-	glBlendFunc(GL_SRC_ALPHA,GL_ONE_MINUS_SRC_ALPHA);
+	glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
 
 	// no need to write to the depth buffer a second time
 	glDepthMask(0);
@@ -372,6 +372,63 @@ void TerrainRenderer::RenderTerrain(bool filtered)
 }
 
 
+void TerrainRenderer::RenderTerrainOverlayTexture(CMatrix3D& textureMatrix)
+{
+	ENSURE(m->phase == Phase_Render);
+
+	std::vector<CPatchRData*>& visiblePatches = m->visiblePatches;
+
+	glEnableClientState(GL_VERTEX_ARRAY);
+	glEnableClientState(GL_TEXTURE_COORD_ARRAY);
+
+	glEnable(GL_TEXTURE_2D);
+	glEnable(GL_BLEND);
+	glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
+	glDepthMask(0);
+
+	glTexEnvi(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_REPLACE);
+
+	glMatrixMode(GL_TEXTURE);
+	glLoadMatrixf(&textureMatrix._11);
+	glMatrixMode(GL_MODELVIEW);
+
+	CPatchRData::RenderStreams(visiblePatches, STREAM_POS|STREAM_POSTOUV0);
+
+	// To make the overlay visible over water, render an additional map-sized
+	// water-height patch
+	// TODO: should we use CPatchRData::RenderWater instead?
+	CBoundingBoxAligned waterBounds;
+	for (size_t i = 0; i < m->visiblePatches.size(); ++i)
+	{
+		CPatchRData* data = m->visiblePatches[i];
+		waterBounds += data->GetWaterBounds();
+	}
+	if (!waterBounds.IsEmpty())
+	{
+		float h = g_Renderer.GetWaterManager()->m_WaterHeight + 0.05f; // add a delta to avoid z-fighting
+		float waterPos[] = {
+			waterBounds[0].X, h, waterBounds[0].Z,
+			waterBounds[1].X, h, waterBounds[0].Z,
+			waterBounds[0].X, h, waterBounds[1].Z,
+			waterBounds[1].X, h, waterBounds[1].Z
+		};
+		glVertexPointer(3, GL_FLOAT, 3*sizeof(float), waterPos);
+		glTexCoordPointer(3, GL_FLOAT, 3*sizeof(float), waterPos);
+		glDrawArrays(GL_TRIANGLE_STRIP, 0, 4);
+	}
+
+	glMatrixMode(GL_TEXTURE);
+	glLoadIdentity();
+	glMatrixMode(GL_MODELVIEW);
+
+	glDepthMask(1);
+	glDisable(GL_BLEND);
+	glDisableClientState(GL_COLOR_ARRAY);
+	glDisableClientState(GL_VERTEX_ARRAY);
+	glDisableClientState(GL_TEXTURE_COORD_ARRAY);
+}
+
+
 ///////////////////////////////////////////////////////////////////
 
 /**
diff --git a/source/renderer/TerrainRenderer.h b/source/renderer/TerrainRenderer.h
index 48bb53e..34ae7a5 100644
--- a/source/renderer/TerrainRenderer.h
+++ b/source/renderer/TerrainRenderer.h
@@ -137,6 +137,13 @@ public:
 	 */
 	void RenderPriorities();
 
+	/**
+	 * Render texture unit 0 over the terrain mesh, with UV coords calculated
+	 * by the given texture matrix.
+	 * Intended for use by TerrainTextureOverlay.
+	 */
+	void RenderTerrainOverlayTexture(CMatrix3D& textureMatrix);
+
 private:
 	TerrainRendererInternals* m;
 
diff --git a/source/simulation2/components/CCmpObstructionManager.cpp b/source/simulation2/components/CCmpObstructionManager.cpp
index e1a8d6a..4e3dafa 100644
--- a/source/simulation2/components/CCmpObstructionManager.cpp
+++ b/source/simulation2/components/CCmpObstructionManager.cpp
@@ -1,4 +1,4 @@
-/* Copyright (C) 2011 Wildfire Games.
+/* Copyright (C) 2012 Wildfire Games.
  * This file is part of 0 A.D.
  *
  * 0 A.D. is free software: you can redistribute it and/or modify
@@ -418,7 +418,8 @@ public:
 	virtual bool TestStaticShape(const IObstructionTestFilter& filter, entity_pos_t x, entity_pos_t z, entity_pos_t a, entity_pos_t w, entity_pos_t h, std::vector<entity_id_t>* out);
 	virtual bool TestUnitShape(const IObstructionTestFilter& filter, entity_pos_t x, entity_pos_t z, entity_pos_t r, std::vector<entity_id_t>* out);
 
-	virtual bool Rasterise(Grid<u8>& grid);
+	virtual void Rasterise(Grid<u16>& grid, entity_pos_t expand, ICmpObstructionManager::flags_t requireMask, u8 setMask);
+	virtual bool RasteriseOld(Grid<u8>& grid);
 	virtual void GetObstructionsInRange(const IObstructionTestFilter& filter, entity_pos_t x0, entity_pos_t z0, entity_pos_t x1, entity_pos_t z1, std::vector<ObstructionSquare>& squares);
 	virtual bool FindMostImportantObstruction(const IObstructionTestFilter& filter, entity_pos_t x, entity_pos_t z, entity_pos_t r, ObstructionSquare& square);
 
@@ -497,6 +498,16 @@ private:
 		return grid.m_DirtyID < m_DirtyID;
 	}
 
+	virtual bool NeedUpdate(size_t* dirtyID)
+	{
+		if (*dirtyID != m_DirtyID)
+		{
+			*dirtyID = m_DirtyID;
+			return true;
+		}
+		return false;
+	}
+
 	/**
 	 * Return whether the given point is within the world bounds by at least r
 	 */
@@ -686,24 +697,77 @@ bool CCmpObstructionManager::TestUnitShape(const IObstructionTestFilter& filter,
 }
 
 /**
- * Compute the tile indexes on the grid nearest to a given point
+ * Compute the navcell indexes on the grid nearest to a given point
  */
-static void NearestTile(entity_pos_t x, entity_pos_t z, u16& i, u16& j, u16 w, u16 h)
+static void NearestNavcell(entity_pos_t x, entity_pos_t z, u16& i, u16& j, u16 w, u16 h)
 {
-	i = (u16)clamp((x / (int)TERRAIN_TILE_SIZE).ToInt_RoundToZero(), 0, w-1);
-	j = (u16)clamp((z / (int)TERRAIN_TILE_SIZE).ToInt_RoundToZero(), 0, h-1);
+	i = (u16)clamp((x / ICmpObstructionManager::NAVCELL_SIZE).ToInt_RoundToZero(), 0, w-1);
+	j = (u16)clamp((z / ICmpObstructionManager::NAVCELL_SIZE).ToInt_RoundToZero(), 0, h-1);
 }
 
 /**
- * Returns the position of the center of the given tile
+ * Returns the position of the center of the given navcell
  */
-static void TileCenter(u16 i, u16 j, entity_pos_t& x, entity_pos_t& z)
+static void NavcellCenter(u16 i, u16 j, entity_pos_t& x, entity_pos_t& z)
+{
+	x = entity_pos_t::FromInt(i*2 + 1).Multiply(ICmpObstructionManager::NAVCELL_SIZE / 2);
+	z = entity_pos_t::FromInt(j*2 + 1).Multiply(ICmpObstructionManager::NAVCELL_SIZE / 2);
+}
+
+void CCmpObstructionManager::Rasterise(Grid<u16>& grid, entity_pos_t expand, ICmpObstructionManager::flags_t requireMask, u8 setMask)
 {
-	x = entity_pos_t::FromInt(i*(int)TERRAIN_TILE_SIZE + (int)TERRAIN_TILE_SIZE/2);
-	z = entity_pos_t::FromInt(j*(int)TERRAIN_TILE_SIZE + (int)TERRAIN_TILE_SIZE/2);
+	PROFILE("Rasterise");
+
+	// Cells are only marked as blocked if the whole cell is strictly inside the shape.
+	// (That ensures the shape's geometric border is always reachable.)
+
+	for (std::map<u32, StaticShape>::iterator it = m_StaticShapes.begin(); it != m_StaticShapes.end(); ++it)
+	{
+		CFixedVector2D center(it->second.x, it->second.z);
+
+		if (it->second.flags & requireMask)
+		{
+			CFixedVector2D halfSize(it->second.hw + expand, it->second.hh + expand);
+			CFixedVector2D halfBound = Geometry::GetHalfBoundingBox(it->second.u, it->second.v, halfSize);
+
+			u16 i0, j0, i1, j1;
+			NearestNavcell(center.X - halfBound.X, center.Y - halfBound.Y, i0, j0, grid.m_W, grid.m_H);
+			NearestNavcell(center.X + halfBound.X, center.Y + halfBound.Y, i1, j1, grid.m_W, grid.m_H);
+			for (u16 j = j0; j <= j1; ++j)
+			{
+				for (u16 i = i0; i <= i1; ++i)
+				{
+					entity_pos_t x, z;
+					NavcellCenter(i, j, x, z);
+					if (Geometry::PointIsInSquare(CFixedVector2D(x - NAVCELL_SIZE/2, z - NAVCELL_SIZE/2) - center, it->second.u, it->second.v, halfSize) &&
+					    Geometry::PointIsInSquare(CFixedVector2D(x + NAVCELL_SIZE/2, z - NAVCELL_SIZE/2) - center, it->second.u, it->second.v, halfSize) &&
+					    Geometry::PointIsInSquare(CFixedVector2D(x + NAVCELL_SIZE/2, z + NAVCELL_SIZE/2) - center, it->second.u, it->second.v, halfSize) &&
+					    Geometry::PointIsInSquare(CFixedVector2D(x - NAVCELL_SIZE/2, z + NAVCELL_SIZE/2) - center, it->second.u, it->second.v, halfSize))
+						grid.set(i, j, grid.get(i, j) | setMask);
+				}
+			}
+		}
+	}
+
+	for (std::map<u32, UnitShape>::iterator it = m_UnitShapes.begin(); it != m_UnitShapes.end(); ++it)
+	{
+		CFixedVector2D center(it->second.x, it->second.z);
+
+		if (it->second.flags & requireMask)
+		{
+			entity_pos_t r = it->second.r + expand;
+
+			u16 i0, j0, i1, j1;
+ 			NearestNavcell(center.X - r, center.Y - r, i0, j0, grid.m_W, grid.m_H);
+ 			NearestNavcell(center.X + r, center.Y + r, i1, j1, grid.m_W, grid.m_H);
+			for (u16 j = j0+1; j < j1; ++j)
+				for (u16 i = i0+1; i < i1; ++i)
+					grid.set(i, j, grid.get(i, j) | setMask);
+		}
+	}
 }
 
-bool CCmpObstructionManager::Rasterise(Grid<u8>& grid)
+bool CCmpObstructionManager::RasteriseOld(Grid<u8>& grid)
 {
 	if (!IsDirty(grid))
 		return false;
@@ -743,14 +807,14 @@ bool CCmpObstructionManager::Rasterise(Grid<u8>& grid)
 			CFixedVector2D halfBound = Geometry::GetHalfBoundingBox(it->second.u, it->second.v, halfSize);
 
 			u16 i0, j0, i1, j1;
-			NearestTile(center.X - halfBound.X, center.Y - halfBound.Y, i0, j0, grid.m_W, grid.m_H);
-			NearestTile(center.X + halfBound.X, center.Y + halfBound.Y, i1, j1, grid.m_W, grid.m_H);
+			NearestNavcell(center.X - halfBound.X, center.Y - halfBound.Y, i0, j0, grid.m_W, grid.m_H);
+			NearestNavcell(center.X + halfBound.X, center.Y + halfBound.Y, i1, j1, grid.m_W, grid.m_H);
 			for (u16 j = j0; j <= j1; ++j)
 			{
 				for (u16 i = i0; i <= i1; ++i)
 				{
 					entity_pos_t x, z;
-					TileCenter(i, j, x, z);
+					NavcellCenter(i, j, x, z);
 					if (Geometry::PointIsInSquare(CFixedVector2D(x, z) - center, it->second.u, it->second.v, halfSize))
 						grid.set(i, j, grid.get(i, j) | TILE_OBSTRUCTED_PATHFINDING);
 				}
@@ -763,14 +827,14 @@ bool CCmpObstructionManager::Rasterise(Grid<u8>& grid)
 			CFixedVector2D halfBound = Geometry::GetHalfBoundingBox(it->second.u, it->second.v, halfSize);
 
 			u16 i0, j0, i1, j1;
-			NearestTile(center.X - halfBound.X, center.Y - halfBound.Y, i0, j0, grid.m_W, grid.m_H);
-			NearestTile(center.X + halfBound.X, center.Y + halfBound.Y, i1, j1, grid.m_W, grid.m_H);
+			NearestNavcell(center.X - halfBound.X, center.Y - halfBound.Y, i0, j0, grid.m_W, grid.m_H);
+			NearestNavcell(center.X + halfBound.X, center.Y + halfBound.Y, i1, j1, grid.m_W, grid.m_H);
 			for (u16 j = j0; j <= j1; ++j)
 			{
 				for (u16 i = i0; i <= i1; ++i)
 				{
 					entity_pos_t x, z;
-					TileCenter(i, j, x, z);
+					NavcellCenter(i, j, x, z);
 					if (Geometry::PointIsInSquare(CFixedVector2D(x, z) - center, it->second.u, it->second.v, halfSize))
 						grid.set(i, j, grid.get(i, j) | TILE_OBSTRUCTED_FOUNDATION);
 				}
@@ -787,8 +851,8 @@ bool CCmpObstructionManager::Rasterise(Grid<u8>& grid)
 			entity_pos_t r = it->second.r + expandPathfinding;
 
 			u16 i0, j0, i1, j1;
-			NearestTile(center.X - r, center.Y - r, i0, j0, grid.m_W, grid.m_H);
-			NearestTile(center.X + r, center.Y + r, i1, j1, grid.m_W, grid.m_H);
+			NearestNavcell(center.X - r, center.Y - r, i0, j0, grid.m_W, grid.m_H);
+			NearestNavcell(center.X + r, center.Y + r, i1, j1, grid.m_W, grid.m_H);
 			for (u16 j = j0; j <= j1; ++j)
 				for (u16 i = i0; i <= i1; ++i)
 					grid.set(i, j, grid.get(i, j) | TILE_OBSTRUCTED_PATHFINDING);
@@ -799,8 +863,8 @@ bool CCmpObstructionManager::Rasterise(Grid<u8>& grid)
 			entity_pos_t r = it->second.r + expandFoundation;
 
 			u16 i0, j0, i1, j1;
-			NearestTile(center.X - r, center.Y - r, i0, j0, grid.m_W, grid.m_H);
-			NearestTile(center.X + r, center.Y + r, i1, j1, grid.m_W, grid.m_H);
+			NearestNavcell(center.X - r, center.Y - r, i0, j0, grid.m_W, grid.m_H);
+			NearestNavcell(center.X + r, center.Y + r, i1, j1, grid.m_W, grid.m_H);
 			for (u16 j = j0; j <= j1; ++j)
 				for (u16 i = i0; i <= i1; ++i)
 					grid.set(i, j, grid.get(i, j) | TILE_OBSTRUCTED_FOUNDATION);
@@ -810,7 +874,7 @@ bool CCmpObstructionManager::Rasterise(Grid<u8>& grid)
 	// Any tiles outside or very near the edge of the map are impassable
 
 	// WARNING: CCmpRangeManager::LosIsOffWorld needs to be kept in sync with this
-	const u16 edgeSize = 3; // number of tiles around the edge that will be off-world
+	const u16 edgeSize = 3 * ICmpObstructionManager::NAVCELLS_PER_TILE; // number of tiles around the edge that will be off-world
 
 	u8 edgeFlags = TILE_OBSTRUCTED_PATHFINDING | TILE_OBSTRUCTED_FOUNDATION | TILE_OUTOFBOUNDS;
 
@@ -837,8 +901,8 @@ bool CCmpObstructionManager::Rasterise(Grid<u8>& grid)
 	else
 	{
 		u16 i0, j0, i1, j1;
-		NearestTile(m_WorldX0, m_WorldZ0, i0, j0, grid.m_W, grid.m_H);
-		NearestTile(m_WorldX1, m_WorldZ1, i1, j1, grid.m_W, grid.m_H);
+		NearestNavcell(m_WorldX0, m_WorldZ0, i0, j0, grid.m_W, grid.m_H);
+		NearestNavcell(m_WorldX1, m_WorldZ1, i1, j1, grid.m_W, grid.m_H);
 
 		for (u16 j = 0; j < grid.m_H; ++j)
 			for (u16 i = 0; i < i0+edgeSize; ++i)
